// -*- c++ -*-
//  Generated by gtkmmproc from ../../gtkextra--/plot.gen_h -- DO NOT MODIFY!
#ifndef _GTKEXTRAMM_PLOT_H
#define _GTKEXTRAMM_PLOT_H

// -*- C++ -*-

/* plot.gen_h
 *
 * Copyright (C) 2000 GtkExtra-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gdk--/drawable.h>
#include <gdk--/color.h>
#include <gtk--/misc.h>

#include <gtk/gtkmisc.h> //needed by gktplot.h
#include <gtk/gtklayout.h> //needed by gktplot.h
#include <gtk/gtkfixed.h> //needed by gtkplotcanvas.h

#include <gtkextra/gtkplot.h>
#include <gtkextra/gtkplotcanvas.h>
#include <gtkextra/gtkplotps.h>
#include <gtkextra/gtkplotprint.h>

#include <gtkextra--/plotdata.h>
#include <gtkextra--/plotaxis.h>

#include "gtkextramm_marshal.h"

using namespace Gtk;

namespace GtkExtra {
class Plot;
class Plot_Class;
}
namespace Gtk { GtkExtra::Plot *wrap (GtkPlot *o); }
namespace GtkExtra
{

class PlotData;

class Plot : public Misc {

public:
  typedef Plot          CppObjectType;
  typedef Plot_Class    CppClassType;
  typedef GtkPlot           BaseObjectType;
  typedef GtkPlotClass      BaseClassType;

private:
  friend class Plot_Class;
  static CppClassType plot_class;

  Plot(const Plot&);
  Plot& operator=(const Plot&); // not implemented

protected:
  void   initialize_class();
  explicit Plot(GtkPlot *castitem);

public:
  static GtkType get_type();
  GtkPlot* gtkobj()             { return (GtkPlot*)(gtkobject); }
  const GtkPlot* gtkobj() const { return (GtkPlot*)(gtkobject); }
  static bool isA(Gtk::Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~Plot();

private:

public:
  Plot();



  Plot(GdkDrawable* drawable);
  Plot(GdkDrawable* drawable,gdouble width, gdouble height);

  /* Does not work (Gdk_Drawable is abstract)
     WRAP_MEMBER(value,drawable,drawable,Gdk_Drawable&,GdkDrawable*);
  */



  //: moved: x, y


  //: resized: width, height


  // Plot function wrapping




  void set_drawable(Gdk_Drawable& drawable);



  void set_background_pixmap(GdkPixmap* pixmap);



  void set_transparent(bool transparent);


  bool is_transparent();



  void get_position(gdouble& x,gdouble& y);



  void get_size(gdouble& width,gdouble& height);


  GtkAllocation get_internal_allocation();



  void set_background(const Gdk_Color& background);


  void paint();


  void refresh(const Gdk_Rectangle& area);


  void move(gdouble x,gdouble y);



  void resize(gdouble width,gdouble height);


  void set_magnification(gdouble magnification);





  void move_resize(gdouble x,gdouble y,gdouble width,gdouble height);





  void get_pixel(gdouble xx,gdouble yy,gdouble& x,gdouble& y);





  void get_point(gint x,gint y,gdouble& xx,gdouble& yy);


  void clip_data(bool clip=true);



  void set_xrange(gdouble xmin,gdouble xmax);




  void set_yrange(gdouble ymin,gdouble ymax);





  void set_range(gdouble xmin,gdouble xmax,gdouble ymin,gdouble ymax);


  void autoscale();



  void get_xrange(gdouble& xmin,gdouble& xmax);



  void get_yrange(gdouble& ymin,gdouble& ymax);



  void set_xscale(GtkPlotScale scale_type);



  void set_yscale(GtkPlotScale scale_type);


  GtkPlotScale get_xscale();


  GtkPlotScale get_yscale();

  GtkPlotText* put_text(gdouble x,gdouble y,const nstring& font,gint height,gint angle,const Gdk_Color& foreground,const Gdk_Color& background,bool transparent,GtkJustification justification,const nstring& text);



  gint remove_text(GtkPlotText* text);

	/*
	These functions act on GtkPlotText, not GtkPlot.
	See GtkExtra header.
	gtk_plot_text_get_size()
	gtk_plot_text_get_area()
	gtk_plot_text_set_attributes()
	gtk_plot_text_set_border()
	*/

  void draw_line(GtkPlotLine line,gint x1,gint y1,gint x2,gint y2);




  void draw_text(GtkPlotText text);

  /* Axis */




  GtkExtra::PlotAxis* get_axis(GtkPlotAxisPos axis);





  void axis_set_visible(GtkPlotAxisPos axis,gboolean visible=true);



  gboolean axis_get_visible(GtkPlotAxisPos axis);





  void axis_set_title(GtkPlotAxisPos axis,const nstring& title);



  void axis_show_title(GtkPlotAxisPos axis);



  void axis_hide_title(GtkPlotAxisPos axis);

  void axis_move_title(GtkPlotAxisPos axis,gint angle,gdouble x,gdouble y);





  void axis_justify_title(GtkPlotAxisPos axis,GtkJustification justification);

  void axis_set_attributes(GtkPlotAxisPos axis,gfloat width,const Gdk_Color& color);

  void axis_get_attributes(GtkPlotAxisPos axis,gfloat& width,Gdk_Color& color);

  void axis_set_ticks(GtkPlotOrientation orientation,gdouble major_step,gint nminor);





  void axis_set_major_ticks(GtkPlotOrientation orientation,gdouble major_step);





  void axis_set_minor_ticks(GtkPlotOrientation orientation,gint nminor);





  void axis_set_ticks_length(GtkPlotAxisPos axis,gint length);





  void axis_set_ticks_width(GtkPlotAxisPos axis,gfloat width);

  void axis_show_ticks(GtkPlotAxisPos axis,gint major_mask,gint minor_mask);

  void axis_set_ticks_limits(GtkPlotOrientation orientation,gdouble begin,gdouble end);




  void axis_unset_ticks_limits(GtkPlotOrientation orientation);





  void axis_show_labels(GtkPlotAxisPos axis,gint labels_mask);

  void axis_title_set_attributes(GtkPlotAxisPos axis,const nstring& font,gint height,gint angle,const Gdk_Color& foreground,const Gdk_Color& background,bool transparent=false,GtkJustification justification=GTK_JUSTIFY_CENTER);

  void axis_labels_set_attributes(GtkPlotAxisPos axis,const nstring& font,gint height,gint angle,const Gdk_Color& foreground,const Gdk_Color& background,bool transparent=false,GtkJustification justification=GTK_JUSTIFY_CENTER);

  void axis_labels_set_numbers(GtkPlotAxisPos axis,gint style,gint precision);

  void axis_labels_set_offset(GtkPlotAxisPos axis,gint offset);




  gint axis_labels_get_offset(GtkPlotAxisPos axis);

  void axis_use_custom_tick_labels(GtkPlotAxisPos axis,gboolean use=true);




  void labels_set_suffix(GtkPlotAxisPos axis,const string& text);




  void labels_set_prefix(GtkPlotAxisPos axis,const string& text);




  string labels_get_suffix(GtkPlotAxisPos axis);




  string labels_get_prefix(GtkPlotAxisPos axis);



  /* Grids */




  void x0_set_visible(gboolean visible);


  gboolean x0_get_visible();



  void y0_set_visible(gboolean visible);


  gboolean y0_get_visible();




  void grids_set_on_top(bool on_top);



  bool grids_get_on_top();

  void grids_set_visible(gboolean vmajor,gboolean vminor,gboolean hmajor,gboolean hminor);

  void grids_get_visible(gboolean& vmajor,gboolean& vminor,gboolean& hmajor,gboolean& hminor);

  void y0line_set_attributes(GtkPlotLineStyle style,gfloat width,const Gdk_Color& color);

  void x0line_set_attributes(GtkPlotLineStyle style,gfloat width,const Gdk_Color& color);

  void major_vgrid_set_attributes(GtkPlotLineStyle style,gfloat width,const Gdk_Color& color);

  void minor_vgrid_set_attributes(GtkPlotLineStyle style,gfloat width,const Gdk_Color& color);

  void major_hgrid_set_attributes(GtkPlotLineStyle style,gfloat width,const Gdk_Color& color);

  void minor_hgrid_set_attributes(GtkPlotLineStyle style,gfloat width,const Gdk_Color& color);

  /* Legends */



  void show_legends();


  void hide_legends();





  void set_legends_border(GtkPlotBorderStyle border,gint shadow_width);





  void legends_move(gdouble x,gdouble y);



  void legends_get_position(gdouble& x,gdouble& y);




  GtkAllocation legends_get_allocation();

  void legends_set_attributes(const nstring& font,gint height,const Gdk_Color& foreground,const Gdk_Color& background);




  void set_line_attributes(GtkPlotLine line);

 /* Datasets */





  void add_data(GtkExtra::PlotData* data);



  gint remove_data(GtkExtra::PlotData* data);


  // Plot PS stuff

  void export_ps(const nstring& file_name,gint orientation,gboolean epsflag,gint page_size);

  void export_ps_with_size(const nstring& file_name,gint orientation,gboolean epsflag,gint units,gint width,gint height);

public:

  union
    {
      CppObjectType * plot_self;
      Gtk::ProxySignal0<void,CppObjectType,BaseObjectType,0> changed;
      Gtk::ProxySignal2<gboolean,gdouble,gdouble,CppObjectType,BaseObjectType,1> moved;
      Gtk::ProxySignal2<gboolean,gdouble,gdouble,CppObjectType,BaseObjectType,2> resized;
    };

protected:
  // impl functions
    virtual void changed_impl();
    virtual gboolean moved_impl(gdouble p0,gdouble p1);
    virtual gboolean resized_impl(gdouble p0,gdouble p1);

};


}

#endif
