// -*- C++ -*-

/* menu_popup.h
 * 
 * Copyright (C) 2000 GtkExtra-- Development Team  
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HEADER_WINDOW_MENU_POPUP
#define HEADER_WINDOW_MENU_POPUP

#include <iostream>
#include <string>

#include "gtk--.h"
#include "gtk--/menu.h"
#include <gtkextra--.h>

using SigC::bind;
using SigC::slot;

class Menu_Popup : public Gtk::Menu
{
public:
  Menu_Popup();
  virtual ~Menu_Popup();

  virtual void Menu_Popup::Set_AllSensitive();

  virtual Gtk::MenuItem* get_MenuItem_AddColumn() const;
  virtual Gtk::MenuItem* get_MenuItem_AddRow() const;
  virtual Gtk::MenuItem* get_MenuItem_InsertRow() const;
  virtual Gtk::MenuItem* get_MenuItem_InsertColumn() const;
  virtual Gtk::MenuItem* get_MenuItem_DeleteRow() const;
  virtual Gtk::MenuItem* get_MenuItem_DeleteColumn() const;
  virtual Gtk::MenuItem* get_MenuItem_ClearCells() const;
  
protected:
  Gtk::MenuItem* m_pMenuItem_AddColumn;
	Gtk::MenuItem* m_pMenuItem_AddRow;
  Gtk::MenuItem* m_pMenuItem_InsertRow;
  Gtk::MenuItem* m_pMenuItem_InsertColumn;
  Gtk::MenuItem* m_pMenuItem_DeleteRow;
  Gtk::MenuItem* m_pMenuItem_DeleteColumn;
  Gtk::MenuItem* m_pMenuItem_ClearCells;

};

#endif //HEADER_WINDOW_MENU_POPUP
